// GpM.cpp : Define the function for app class
//

#include "stdafx.h"
#include "defsfile.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGpMApp

BEGIN_MESSAGE_MAP(CGpMApp, CWinApp)
	//{{AFX_MSG_MAP(CGpMApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// 
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGpMApp Crate the class
CGpMApp::CGpMApp()
{
}


CGpMApp::~CGpMApp()
{
	CloseMtoM();		
}


/////////////////////////////////////////////////////////////////////////////

CGpMApp theApp;


/////////////////////////////////////////////////////////////////////////////
// CGpMApp Initialize class

BOOL CGpMApp::InitInstance()
{

#ifdef _AFXDLL
	Enable3dControls();
#else
	Enable3dControlsStatic();
#endif

	//	Item the modules for simulate the draw on Windows
	if(!InitGpWin()){
		return FALSE  ;
	}

    SetRegistryKey ("GP MtoM for Windows Sample Program");
 
	LoadStdProfileSettings();

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_GPMTYPE,
		RUNTIME_CLASS(CGpMDoc),
		RUNTIME_CLASS(CChildFrame), 
		RUNTIME_CLASS(CGpMView));
	AddDocTemplate(pDocTemplate);

	// Create Main MDI Frame
	m_pMainFrame = new CMainFrame;
	if (!m_pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = m_pMainFrame;

	// Cause the main window has init, show and update.
	m_pMainFrame->ShowWindow(m_nCmdShow);
	m_pMainFrame->UpdateWindow();

	// Shell command
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	//	Create the GP pen object
	m_pGpPens[0] = new CGpPenEscT() ;	m_dwGpPen_ID[0] = ID_GpPenEscT ;
	m_pGpPens[1] = new CGpPenEscL() ;	m_dwGpPen_ID[1] = ID_GpPenEscL ;
	m_pGpPens[2] = new CGpPenEscB() ;	m_dwGpPen_ID[2] = ID_GpPenEscB ;
	m_pGpPens[3] = new CGpPenEscS() ;	m_dwGpPen_ID[3] = ID_GpPenEscS ;
	m_pGpPens[4] = new CGpPenEscC() ;	m_dwGpPen_ID[4] = ID_GpPenEscC ;
	m_pGpPens[5] = new CGpPenEscA() ;	m_dwGpPen_ID[5] = ID_GpPenEscA ;
	m_pGpPens[6] = new CGpPenEscG() ;	m_dwGpPen_ID[6] = ID_GpPenEscG ;
	m_pGpPens[7] = new CGpPenEscP() ;	m_dwGpPen_ID[7] = ID_GpPenEscP ;
	m_pGpPens[8] = new CGpPenEsc_t() ;	m_dwGpPen_ID[8] = ID_GpPenEsc_t ;
	m_pGpPens[9] = new CGpPenEsc_l() ;	m_dwGpPen_ID[9] = ID_GpPenEsc_l ;
	m_pGpPens[10] = new CGpPenEsc_b() ;	m_dwGpPen_ID[10] = ID_GpPenEsc_b ;
	m_pGpPens[11] = new CGpPenEsc_s() ;	m_dwGpPen_ID[11] = ID_GpPenEsc_s ;
	m_pGpPens[12] = new CGpPenEsc_c() ;	m_dwGpPen_ID[12] = ID_GpPenEsc_c ;
	m_pGpPens[13] = new CGpPenEsc_g() ;	m_dwGpPen_ID[13] = ID_GpPenEsc_g ;
	m_pGpPens[14] = new CGpPenEscY() ;	m_dwGpPen_ID[14] = ID_GpPenEscY ;
	m_pGpPens[15] = new CGpPenEsc_y() ;	m_dwGpPen_ID[15] = ID_GpPenEsc_y ;

	//	Set the default color
	m_cDisplayColor = 7 ;
	m_cBackColor = 0    ;

	//	Init = 1:1
	m_TargetGP_1ToN = FALSE	; 

	//	If set 1:N, theApp have the SocketClass, So init that
	//	(1:1, the document class have that.)

	//	1, Don't call CreateMtomSocket(), cause already called from constractor of CMSock.
	//	2. Set B_dwTransitionType_BroadCast tp the default value of 1:N communicate.

	SetTransitionType(B_dwTransitionType_BroadCast);

	int iError =  OpenMtoMLAN( NULL ) ;
	if( iError ){
		DispMtoMError( iError,MtoMGetLastError() ) ;
//		return FALSE ;	@@@@@
	}
	
	SetCurrentGpPen( ID_GpPenEscT );

	m_pMainFrame->m_wndGpList.UpdateData(FALSE);
	m_pMainFrame->m_wndGpList.OnInitDialog() ;
	return TRUE;
}

//	Set GP Pen Object
void CGpMApp::SetCurrentGpPen(DWORD dwGpPen_ID) 
{
	int i ;
	// delete all
	for( i = 0 ; i < GpPen_MAX ; i ++){
		m_pGpPens[i] ->ShowWindow( SW_HIDE );
	}

	//	Serch the item
	for( i = 0 ; i < GpPen_MAX-1 ; i ++){
		if( m_dwGpPen_ID[i] == dwGpPen_ID ){
			break ;
		}
	}
	
	// Set Current Dialog
	m_pCurrentGpPen = m_pGpPens[i] ;
	m_pGpPens[i]->ShowWindow( SW_SHOW );

	//	Update the Buttons
	m_pMainFrame->ButtonDraw();
}



/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg Dialog

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

  	// ClassWizard create the virtual methods and override them
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// Message Handler͂܂B
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Message Handler܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// Dialogs邽߂̃AvP[V R}h
void CGpMApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CGpMApp R}h
